<?php
namespace Controllers;

// Контроллер для чеков
class Receipts extends Controller {
	public $products, $changes, $receiptlines, $receipts_types, $api_data, $device;

	public function __construct() {
		parent::__construct();
		$device=$this->f3->get('GET.device');
		if(!$device)$device='kkm';
		$this->device=$device;
		$this->model=new \Models\Receipts($this->db, $this->f3, $device);
		$this->receiptlines=new \Models\Receiptlines($this->db, $this->f3);
		$this->products=new \Models\Products($this->db, $this->f3);
		$this->changes=new \Models\Changes($this->db, $this->f3);
		$this->receipts_types=array(
			'sales'=>$this->f3->get('receipt_sales'),
			'return'=>$this->f3->get('receipt_return'),
			'cashin'=>$this->f3->get('receipt_cashin'),
			'cashout'=>$this->f3->get('receipt_cashout')
		);
		$this->api_data=$this->controller->get_api_config();
	}

	// Раздел продаж
	function sales() {
		if($this->sets['product_menu']=='1') {
			$c=new \Controllers\Products();
			$c->list();
		}
		$scales=new \Models\Scales($this->db, $this->f3);
		$this->f3->set('scales_settings', $scales->sets);
		// Проверяем нужно ли выбрать стол
		if($this->sets['cafe_mode']==1) {
			$table_id=$this->f3->get('GET.table_id');
			if(!$table_id) {
				$table_id=$this->f3->get('SESSION.table_id');
			}
			if(!$table_id || $this->f3->get('GET.room_id')) { // Если стол не выбран, то откроем режим выбора столов
				$r=new \Controllers\Rooms($this->db, $this->f3);
				$r->select_table();
				return;
			}
			$r=new \Models\Rooms($this->db, $this->f3);
			$rooms=$r->select_rooms();
			$room=$rooms[0];
			$this->f3->set('rooms', $rooms);
			$fr=new \Models\Fr($this->db, $this->f3, 'kitchen', false);
			$this->f3->set('kitchen_sets', $fr->sets);
			$fr=new \Models\Fr($this->db, $this->f3, 'bar', false);
			$this->f3->set('bar_sets', $fr->sets);
		}
		else {
			$rooms=array();
			$table_id=0;
		}
		$this->f3->set('modifiers', $this->products->count('related!="" AND date_delete=0'));
		$this->f3->set('SESSION.table_id', $table_id);
		if(!$this->f3->get('return') && !$this->f3->get('AJAX')) {
			$this->cd->seller_txt();
		}
		if($this->f3->get('return')) {
			$this->cd->close_txt();
		}
		$receiptlines=array();
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], true, (int) $this->sets['view_all_receipts']);
		if($receipt['success']) {
			if(!empty($rooms)) {
				foreach ($rooms as $r) {
					if($r['id']==$receipt['receipt']['table']['room']) {
						$this->f3->set('room', $r);
						break;
					}
				}
			}
			$this->f3->set('SESSION.receipt_id', $receipt['receipt']['id']);
			$receiptlines=$this->receiptlines->select_lines(array('receipt_id=?', $receipt['receipt']['id']));
			$this->f3->set('receiptlines', $receiptlines);
			$this->f3->set('receipt', $receipt['receipt']);
			$this->f3->set('open_receipts', $receipt['open']);
			$line_id=$this->f3->get('GET.id');
			if(!$line_id && $receiptlines) {
				foreach (array_reverse($receiptlines) as $l) {
					if($l['parent_id']==0) {
						$line_id=$l['id'];
						break;
					}
				}
				//$line_id=array_pop($receiptlines)['id'];
			}
			$this->f3->set('s', $line_id);
			$loyalty_models=new \Models\Loyalty($this->db, $this->f3);
			$this->f3->set('discounts', $loyalty_models->select_discounts());
			$this->f3->set('page_data', $this->model->page_data('sales'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message($receipt['txt']));
		}
	}

	// Раздел возрата
	function return() {
		$id=$this->f3->get('GET.id');
		if(!$id) {
			$this->f3->set('return', 1);
			$this->sales();
			$this->f3->set('page_data["title"]', $this->model->page_data('return')['title']);
		}
		else {
			$receipt=$this->model->select_receipts(array('r.id=? AND r.type=1', $id), array('limit'=>1));
			if($receipt) {
				$p=new \Models\Paymentmethods($this->db, $this->f3);
				$paymentmethods=$p->select_method(null);
				foreach ($paymentmethods as $n => $p) {
					$pays[$p['id']]=$p['title'];
				}
				$this->f3->set('paymentmethods', $pays);
				$this->f3->set('receipt', $receipt[0]);
				$this->f3->set('page_data', $this->model->page_data('return'));
			}
			else {
				$this->f3->set('page_data', $this->messages->message('not_found'));
			}
		}
	}

	// Поиск чеков
	function search() {
		$id=$this->f3->get('GET.id');
		$changes=$this->f3->get('GET.changes');
		$barcode=$this->f3->get('GET.barcode');
		$s=new \Models\Settings($this->f3, $this->db);
		$sets=$s->get_settings(array('weight_code_pr', 'card_code_pr'));
		// Проверяем штрих-код на принадлежность к весовому типу
		if(mb_substr($barcode, 0, 2)==$sets['weight_code_pr'] && mb_strlen($barcode)==13) {
			$barcode=mb_substr($barcode, 0, 7);
		}
		$dates=$this->f3->get('GET.dates');
		$type=$this->f3->get('GET.type');
		if($dates) {
			$dates=str_replace(' ', '', $dates);
			$dates=explode('-', $dates);
			$dates[0]=strtotime($dates[0]);
			$dates[1]=strtotime($dates[1]);
		}
		$limit=$this->f3->get('lines_of_page');
		$page=$this->f3->get('GET.page');
		if(!$page)$page=1;
		$receipts=$this->model->search($id, $changes, $barcode, $dates, $type, ($page-1)*$limit, $limit);
		$this->f3->set('pagination', $this->pagination($receipts['count'], $page));
		$this->f3->set('receipts', $receipts['receipts']);
		$this->f3->set('page_data', $this->model->page_data('search'));
	}

	// Просмотр чека
	function show() {
		$id=$this->f3->get('GET.id');
		$page_data=$this->messages->message('not_found');
		if($id) {
			$receipts=$this->model->select_receipts(array('r.id=?', $id), array('limit'=>1));
			if($receipts) {
				$p=new \Models\Paymentmethods($this->db, $this->f3);
				$paymentmethods=$p->select_method();
				foreach ($paymentmethods as $n => $p) {
					$pays[$p['id']]=$p['title'];
				}
				$this->f3->set('paymentmethods', $pays);
				$fr=new \Models\Fr($this->db, $this->f3);
				$sets=$fr->get_fr();
				$this->f3->set('fr', $sets);
				$this->f3->set('receipt', $receipts[0]);
				$page_data=$this->model->page_data('show');
			}
		}
		$this->f3->set('page_data', $page_data);
	}

	//Применение программм лояльности
	function loyalty($receipt, $product) {
		$с=new \Models\Productcategories($this->db, $this->f3);
		$parents=$с->get_parents($product['category_id']); // Родительские категории
		// Получаем программы лояльности
		$l=new \Models\Loyalty($this->db, $this->f3);
		$loyalty=$l->get_loyalty($receipt['partner_id'], $product, $parents);
		if(count($loyalty)>0) {
			$this->receiptlines->apply_loyalty($receipt, $product, $parents, $loyalty);
		}
	}

	// Отмена акций
	function cancel_loyalty($receipt, $product) {
		$this->receiptlines->cancel_loyalty($receipt, $product);
	}

	// Добавление маркированного товара
	function post_add_marking() {
		$post=$this->f3->get('POST');
		foreach ($post['product'] as $p) {
			$count=$post['count'][$p];
			$mark=json_encode($post['mark'][$p]);
			$this->f3->set('GET.product_id', $p);
			$this->f3->set('GET.count', $count);
			$this->f3->set('GET.mark', $mark);
			$res=$this->add_line();
		}
	}

	// добавление строки в чек
	function add_line() {
		$result=array(
			'success'=>false,
			'txt'=>$this->messages->message('not_found')['txt']
		);
		$product_id=$this->f3->get('GET.product_id');
		$count=$this->f3->get('GET.count');
		$mark=$this->f3->get('GET.mark');
		if(is_array($mark)) {
			$mark=json_encode($mark);
		}
		//if(!$count) $count=1;
		if(isset($product_id)) {
			if($product_id>0) {
				$res=$this->products->select_product(array('p.id=?', $product_id), array('limit'=>1));
				if($count>1 && $res[0]['marking']>0 && !$mark) {
					$this->f3->set('page_data', $this->messages->message('quantity_marked_goods_may_not_exceed_1'));
					return;
				}
				if(!isset($count)) {
					$count=$res[0]['quantity'];
				}
				$res[0]['count']=$count;
				if(($res[0]['marking']>0 && !$mark) || ($res[0]['marking']==1 && $mark=='[""]')) {
					if($mark=='[""]') {
						$this->f3->set('page_data', $this->messages->message('incorrect_data'));
						return;
					}
					$this->f3->set('products', $res);
					$this->f3->set('page_data', $this->model->page_data('add_marking'));
					return;
				}
				if($mark=='[""]')$mark='';
				$mark_code=json_decode($mark)[0];
				if($mark!='' && $this->sets['check_mark']>0 && $res[0]['egais']==0 && (!$this->f3->get('GET.not_check_mark') || $this->sets['check_mark']==2)) {
					// Проверяем маркировку товара
					$mark_res=$this->model->check_mark(urldecode($mark_code));
					if($mark_res['success']===false) {
						$this->f3->set('mark_code', $mark_code);
						$this->f3->set('txt', $this->messages->message($mark_res['txt'])['txt']);
						$this->f3->set('page_data', $this->model->page_data('marking_error'));
						return;
					}
				}
				if($mark!='' && $this->sets['check_egais']>0 && $this->sets['egais']==1 && $res[0]['egais']==1 && (!$this->f3->get('GET.not_check_mark') || $this->sets['check_egais']==2)) {
					// Проверяем товар ЕГАИС
					$egais_res=$this->model->check_egais($mark_code);
					if($egais_res['success']===false) {
						$this->f3->set('mark_code', $mark_code);
						$this->f3->set('txt', $this->messages->message($egais_res['txt'])['txt']);
						$this->f3->set('page_data', $this->model->page_data('egais_error'));
						return;
					}
				}
				if($mark!='' && $this->sets['check_mrc']>0 && $res[0]['egais']==0 && (!$this->f3->get('GET.not_check_mrc') || $this->sets['check_mrc']==2)) {
					$price=$res[0]['price']+($res[0]['price']*($res[0]['vat']/100))*max(0, $res[0]['vat_type']);
					$mrc=$this->model->mark_for_chz(urldecode($mark_code))['mrc'];
					if($mrc<$price && $mrc>0) {
						$this->f3->set('mark_code', $mark_code);
						$this->f3->set('txt', $this->messages->message('mrc_error')['txt']);
						$this->f3->set('page_data', $this->model->page_data('mrc_error'));
						return;
					}
				}
				$res[0]['mark']=$mark;
			}
			else {
				if(in_array('receipts/freesales', $this->f3->get('SESSION.user.module'))) {
					if(!$count) $count=1;
					$res[0]=array(
						'title'=>'Свободная продажа',
						'id'=>0,
						'price'=>$this->f3->get('GET.price'),
						'vat'=>0,
						'vat_type'=>0
					);
				}
				else {
					$this->f3->set('page_data', $this->messages->message('free_sales_not_access'));
					return;
				}
			}
			if(!empty($res)) { // Если есть что добавлять в чек

				// Узнаем окрытый чек
				$result=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], true, (int) $this->sets['view_all_receipts']);
				if($result['success']) {
					$receipt=$result['receipt'];
					$parent_id=$this->f3->get('GET.parent_id');
					$result=$this->receiptlines->add_line($receipt['id'], $res[0], $count, $parent_id);
					if($result['success']) {
						$this->cd->print_line($result['line'], $count);
						if($result['line']['related']!='' && (int) $this->sets['modifiers_window']==1)  {
							$result['close_all_window']=false;
							$result['next_step']='/receipts/modifiers?line_id='.$result['id'];
						}
					}
					// Применяем акции
					$this->loyalty($receipt, $res[0]);
				}
				$result['txt']=$this->messages->message($result['txt'])['txt'];
			}
		}

		echo json_encode($result);
		exit();
	}

	// Меняем строку в чеке
	function change_line() {
		$line_id=$this->f3->get('REQUEST.line_id');
		$count=$this->f3->get('REQUEST.count');
		$price=$this->f3->get('REQUEST.price');
		$discount=$this->f3->get('REQUEST.discount_line');
		$description=$this->f3->get('REQUEST.description');
		$loyalty=$this->f3->get('REQUEST.loyalty');
		if(!$loyalty)$loyalty=false;
		if($line_id>=0 && ($count>=0 || $price>=0)) {
			$res=$this->receiptlines->change_line($line_id, $count, $price, $discount, $description, $loyalty);
			if($res['success']) {
				$this->cd->print_line($res['line'], $res['line']['count']);
				// Если было изменено кол-во, то надо пересчитать акции
				if($count) {
					// Документ, к которому применяется скидка
					$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id']);
					// Товар, к которому применяется скидка
					$product=$this->products->select_product(array('p.id=?', $res['line']['product_id']), array('limit'=>1));
					// Чтобы корректно применить акции, придется вернуть все как было до акций
					$this->cancel_loyalty($receipt['receipt'], $product[0]);
					// А теперь применим акции
					$this->loyalty($receipt['receipt'], $product[0]);
				}

			}
			$res['txt']=$this->messages->message($res['txt'])['txt'];
		}
		else {
			$res=array(
				'success'=>false,
				'txt'=>$this->messages->message('not_enough_data')['txt']
			);
		}

		echo json_encode($res);
		exit();
	}

	// Редактируем цену в чеке
	function change_price() {
		$line_id=$this->f3->get('GET.line_id');
		$lines=$this->receiptlines->select_lines(array('id=?', $line_id), array('limit'=>1));
		$product=$this->products->select_product(array('p.id=?', $lines[0]['product_id']), array('limit'=>1));
		if($lines[0]) {
			$lines[0]['product_price']=$product[0]['price'];
			$lines[0]['buy_price']=$product[0]['buy_price'];
			$this->f3->set('line', $lines[0]);
			$this->f3->set('page_data', $this->model->page_data('change_price'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message('not_enough_data'));
		}
	}

	// Сохраняем новую цену продажи
	function post_change_price() {
		$price=$this->f3->get('POST.price'); // Установленная цена
		$price_db=$this->f3->get('POST.price_db'); // Цена из справочника
		if($price!=$price_db) {
			$this->f3->set('POST.description', 'Изменение цены кассиром '.$this->f3->get('SESSION.user.short_name'));
			$this->f3->set('POST.loyalty', 2);
		}
		$this->change_line();
	}

	// Удаляем строки
	function delete_line() {
		$this->cd->clear_cd();
		$line_id=$this->f3->get('GET.line_id');
		if($line_id>=0 || $line_id=='all') {
			$res=$this->receiptlines->delete_line($line_id);
			if($res['success'] && $line_id!='all') {
				// Применяем акции
				// Документ, к которому применяется скидка
				$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], false, (int) $this->sets['view_all_receipts']);
				// Товар, к которому применяется скидка
				$product=$this->products->select_product(array('p.id=?', $res['line']['product_id']), array('limit'=>1));
				// Чтобы корректно применить акции, придется вернуть все как было до акций
				$this->cancel_loyalty($receipt['receipt'], $product[0]);
				// А теперь применим акции
				$this->loyalty($receipt['receipt'], $product[0]);
			}
			$res['txt']=$this->messages->message($res['txt'])['txt'];
			if($line_id=='all') {
				$this->model->set_discount(0);
			}
		}
		else {
			$res=array(
				'success'=>false,
				'txt'=>$this->messages->message('not_enough_data')['txt']
			);
		}

		echo json_encode($res);
		exit();
	}

	// Установка скидки на чек
	function discount() {
		$discount=$this->f3->get('GET.discount');
		$res=$this->model->set_discount($discount);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// выбор оплаты
	function pay() {
		$sum=$this->f3->get('GET.sum');
		$pay=$this->f3->get('GET.pay');
		if($sum && $pay) {
			$this->cd->total_price($sum, $pay);
			exit();
		}
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], false, (int) $this->sets['view_all_receipts']);
		if(!$receipt['success']) {
			$this->f3->set('page_data', $this->messages->message('not_enough_data'));
			return;
		}
		$lines=$this->receiptlines->select_lines(array('receipt_id=?', $receipt['receipt']['id']));
		if(empty($lines)) {
			$this->f3->set('page_data', $this->messages->message('not_enough_data'));
			return;
		}
		$discount=$receipt['receipt']['discount'];
		$sum=$this->receiptlines->get_sum($lines, $discount);
		$this->f3->set('sum', $sum);
		$p=new \Models\Paymentmethods($this->db, $this->f3);
		$paymentmethods=$p->select_method();
		$type=$this->f3->get('GET.type');
		if($type!=$this->receipts_types['return']) $type=$this->receipts_types['sales'];
		if($type==$this->receipts_types['sales']) {
			$this->cd->total_price($sum, $sum);
		}
		$this->f3->set('fr', $this->model->fr->sets['active']);
		$this->f3->set('type', $type);
		$this->f3->set('paymentmethods', $paymentmethods);
		$this->f3->set('receipt', $receipt['receipt']);
		$this->f3->set('page_data', $this->model->page_data('paymentmethods'));
	}

	// Пробиваем чек
	function ready() {
		$paymentmethod=$this->f3->get('REQUEST.paymentmethod');
		$client_sum=$this->f3->get('REQUEST.client_sum');
		$client=$this->f3->get('REQUEST.client');
		$sales_receipts=$this->f3->get('REQUEST.sales_receipts');
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], false, (int) $this->sets['view_all_receipts']);
		if(!$receipt['success']) {
			$res=array(
				'success'=>false,
				'txt'=>$this->messages->message('not_enough_data')['txt']
			);
		}
		else {
			$lines=$this->receiptlines->select_lines(array('receipt_id=?', $receipt['receipt']['id']));
			if($lines && $paymentmethod && $client_sum) {
				$discount=$this->f3->get('POST.discount');
				if(!isset($discount)) $discount=$receipt['receipt']['discount'];
				$type=$this->f3->get('REQUEST.type');
				if(!$type) $type=$this->receipts_types['sales']; // Продажа
				$partner_id=$this->f3->get('POST.partner_id');
				$sum=$this->receiptlines->get_sum($lines, $discount);
				// Узнаем смену
				$change=$this->changes->get_change();

				if(!empty($change)) {
					// Создаем чек
					$res=$this->model->add_ticket($receipt['receipt']['id'], $change, $type, $paymentmethod, $client_sum, $sum, $lines, $client, $discount, $partner_id);
					// Записываем скидку в товары
					if($res['success']) {
						$res=$this->receiptlines->save_lines($receipt['receipt']['id'], $discount);
						if($type==1) {
							$this->cd->seller_txt();
						}
						if($this->sets['cafe_mode']==1) {
							$this->f3->clear('SESSION.table_id');
							$this->f3->clear('SESSION.receipt_id');
							unset($res['reload'], $res['reload_menu']);
							$res['function']='$("#screen").load("?room_id='.$receipt['receipt']['table']['room'].' #screen_window")';
						}
						else {
							$t=$this->model->get_empty($this->api_data['rm_id'], $this->api_data['store_id']);
							if($t>0) {
								$this->f3->set('SESSION.receipt_id', $t);
							}
							else {
								$this->model->open_new($this->api_data['rm_id'], $this->api_data['store_id']);
							}
						}
						if($sales_receipts==1) {
							$this->model->print($receipt['receipt']['id']);
						}
					}
					$res['txt']=$this->messages->message($res['txt'])['txt'];
				}
				else {
					$res=array(
						'success'=>false,
						'txt'=>$this->messages->message('change_not_open')['txt']
					);
				}
			}
			else {
				$res=array(
					'success'=>false,
					'txt'=>$this->messages->message('not_enough_data')['txt']
				);
			}
		}

		echo json_encode($res);
		exit();
	}

	// Создаем чек продажи
	function post_sales() {
		$hold=$this->f3->get('POST.hold');
		if($hold==1) {
			$this->f3->set('hold', 1);
		}
		$this->ready();
	}

	// Создаем возвратный чек
	function post_return() {
		// Создаем чек совсеми данными
		$post=$this->f3->get('REQUEST');
		if($post['hold']==1) {
			$this->f3->set('hold', 1);
		}
		// Узнаем смену
		$change=$this->changes->get_change();
		// Узнаем сумму строк
		$sum=$this->receiptlines->get_sum($post['receiptlines'], $post['discount']);
		$post['sum']=$sum;
		$res=$this->model->ticket_return($this->api_data['rm_id'], $this->api_data['store_id'], $change, $post);
		if($res['success']) {
			// Добавляем строки
			foreach ($post['receiptlines'] as $line_n=>$line) {
				if(isset($line['mark']) && $line['mark']!='') {
					$line['mark']=json_encode(array($line['mark']));
					$post['receiptlines'][$line_n]['mark']=$line['mark'];
				}
				$result=$this->receiptlines->add_line($res['id'], $line, $line['count']);
				if(!$result['success']) {
					$this->model->delete_receipt($res['id']);
					$res=$result;
					break;
				}
			}
			$res=$this->model->ticket_ready($res['receipt'], $post);
		}
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Внесение денег в кассу
	function cashin() {
		$this->f3->set('auto_cashout', $this->model->fr->sets['auto_incassation']);
		$this->f3->set('page_data', $this->model->page_data('cashin'));
	}

	// Изъятие денег из кассы
	function cashout() {
		$this->f3->set('auto_cashout', $this->model->fr->sets['auto_incassation']);
		$this->f3->set('page_data', $this->model->page_data('cashout'));
	}

	// Пытаемся внести деньги в кассу
	function post_cashin() {
		$hold=$this->f3->get('POST.hold');
		if($hold==1) {
			$this->f3->set('hold', 1);
		}
		$sum=$this->f3->get('POST.sum');
		$description=$this->f3->get('POST.description');
		$create_receipt=$this->f3->get('POST.create_receipt');
		if($sum) {
			if($sum>0)$type=$this->receipts_types['cashin'];
			else $type=$this->receipts_types['cashout'];
			$change=$this->changes->get_change();
			if($change) {
				$api=$this->controller->get_api_config();
				$p=new \Models\Paymentmethods($this->db, $this->f3);
				$pay=$p->select_method('cash=1');
				$res=$this->model->cashin($api, $change, $pay[0]['id'],  $sum, $type, $create_receipt, $description);
				$res['txt']=$this->messages->message($res['txt'])['txt'];
			}
			else {
				$res=array(
					'success'=>false,
					'txt'=>$this->messages->message('change_not_open')['txt']
				);
			}
		}
		else {
			$res=array(
				'success'=>false,
				'txt'=>$res=$this->messages->message('not_enough_data')['txt']
			);
		}

		echo json_encode($res);
		exit();
	}

	// Изымаем деньги из кассы
	function post_cashout() {
		$this->f3->set('POST.sum', -$this->f3->get('POST.sum'));
		$this->post_cashin();
	}

	// Принудительное пробитие чека, при ошибке ФР
	function post_hold() {
		$this->f3->set('hold', 1);
		$type=$this->f3->get('GET.type');
		$method='post_'.$type;
		$this->$method();
	}

	// Страница смены и отчеты
	function reports() {
		$ch=$this->f3->get('GET.change');
		if(!$ch) {
			$change=$this->changes->get_change(false);
		}
		else {
			$ch=$this->changes->load(array('id=?', $ch));
			if(!$ch->dry()) {
				$change=$ch->cast();
			}
			else {
				$this->f3->set('error', $this->messages->message('not_found')['txt']);
			}
		}
		if($change) {
			$report=$this->model->change_statistic($change['id']);
			$p=new \Models\Paymentmethods($this->db, $this->f3);
			$paymentmethods=$p->select_method();
			foreach ($paymentmethods as $p) {
				$pays[$p['id']]=array('title'=>$p['title'], 'cash'=>$p['cash']);
			}
			$this->f3->set('paymentmethods', $pays);
		}
		$report=$this->model->change_statistic($change['id']);
		$this->f3->set('report', $report);
		$this->f3->set('change', $change);
		$this->f3->set('page_data', $this->model->page_data('reports'));
	}

	// Применение программ лояльности ко всему чеку
	function loyalty_receipt($cancel=false) {
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'])['receipt'];
		$lines=$this->receiptlines->select_lines(array('receipt_id=?', $receipt['id']));
		if($lines) {
			$in='';
			$val=array();
			foreach ($lines as $l) {
				if($in!='')$in.=', ';
				$in.='?';
				$val[]=$l['product_id'];
			}
			$products=$this->products->select_product(array('p.id IN ('.$in.')', $val));
			if($products) {
				foreach ($products as $p) {
					// Если сначала нужно сбросить акции
					if($cancel===true) {
						$this->cancel_loyalty($receipt, $p);
					}
					$this->loyalty($receipt, $p);
				}
			}
		}
	}

	// Убрать клиента из чека
	function remove_partner() {
		$res=$this->model->remove_partner($this->f3->get('SESSION.receipt_id'));
		if($res['success']) {
			$this->loyalty_receipt(true);
		}
		echo json_encode($res);
		exit();
	}

	// Добавление клиента в чек
	function add_partner() {
		$card=$this->f3->get('GET.card');
		if(!$card)$card=-1;
		$p=new \Models\Partners($this->db, $this->f3);
		$partner=$p->select_partner(array('card=?', $card), array('limit'=>1));
		if(empty($partner) && !$this->f3->get('new_partner')) {
			$this->f3->set('page_data', $p->page_data('not_found'));
			return;
		}
		if(empty($partner)) {
			$partner[0]=array(
				'id'=>'',
				'card'=>$card,
				'discount'=>0,
				'email'=>'',
				'phone'=>''
			);
		}
		$res=$this->model->add_partner($this->f3->get('SESSION.receipt_id'), $partner[0]);
		if($res['success']) {
			$this->loyalty_receipt(true);
		}
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Отчет по секциям
	function rep_sections() {
		$res=$this->model->rep_sections();
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}

	// Печать копии последнего чека
	function print_last() {
		$res=$this->model->print_last();
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Открытие нового пустого чека
	function new() {
		$res=$this->model->open_new($this->api_data['rm_id'], $this->api_data['store_id']);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Переключение на другой чек
	function switch() {
		$id=$this->f3->get('GET.id');
		$res=$this->model->switch_receipt($id);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Страница со списком всех открытых чеков на кассе
	function all_open() {
		$limit=$this->f3->get('lines_of_page');
		$page=$this->f3->get('GET.page');
		if(!is_numeric($page) || $page<=0)$page=1;
		$receipts=$this->model->all_open(($page-1)*$limit, $limit);
		$this->f3->set('pagination', $this->pagination($receipts['count'], $page));
		$this->f3->set('receipts', $receipts['receipts']);
		$this->f3->set('page_data', $this->model->page_data('all_open'));
	}

	// Перехват чека
	function intercept() {
		$id=$this->f3->get('GET.id');
		$res=$this->model->intercept($this->api_data['rm_id'], $this->api_data['store_id'], $id);
		if($res['success']) {
			$this->f3->set('SESSION.receipt_id', $id);
			$this->f3->set('SESSION.table_id', $res['receipt']['table_id']);
		}
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Окно перемещения чека на другой стол
	function move() {
		if($this->f3->get('GET.table_id')) {
			$this->move_receipt();
			return;
		}
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], true);
		if(!$receipt['success']) {
			$this->f3->set('page_data', $this->messages->message($res['txt']));
			return;
		}
		$r=new \Models\Rooms($this->db, $this->f3);
		$rooms=$r->select_rooms();
		$room=$rooms[0];
		$room_id=$this->f3->get('GET.room_id');
		if(!$room_id) {
			$room_id=$receipt['receipt']['table']['room'];
		}

		foreach ($rooms as $v) {
			if($v['id']==$room_id) {
				$room=$v;
				break;
			}
		}

		if(!empty($room)) {
			// Если зал выбран, то находим столы
			$t=new \Models\Tables($this->db, $this->f3);
			$tables=$t->tables_form_room($room_id, true);
		}
		$this->f3->set('move', true);
		$this->f3->set('rooms', $rooms);
		$this->f3->set('room', $room);
		$this->f3->set('tables', $tables);
		$this->f3->set('receipt', $receipt['receipt']);
		$this->f3->set('page_data', $this->model->page_data('move'));
	}

	// Перемещение чека на другой стол
	function move_receipt() {
		$table_id=$this->f3->get('GET.table_id');
		$res=$this->model->move_receipt($this->f3->get('SESSION.receipt_id'), $table_id);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Форма для поиска заказов из интернет-магазина
	function online_order() {
		$this->f3->set('page_data', $this->model->page_data('online_order'));
	}

	// Ищем интернет-заказы
	function search_online_order() {
		$data=$this->f3->get('GET');
		$page=$data['page'];
		if(!$page)$page=1;
		$lines_of_page=$this->f3->get('lines_of_page');
		$data['offset']=($page-1)*$lines_of_page;
		$data['limit']=$lines_of_page;
		$api_data=$this->controller->get_api_config();
		$api=new \Models\Api($this->f3, $api_data['domen'], $api_data['pass'], $api_data['store_id'], $api_data['count']);
		// Отправляем запрос на поиск
		$res=$api->online_order($data);
		if($res['success']) {
			// Показываем результат поиска
			$this->f3->set('pagination', $this->pagination($res['all'], $page));
			$this->f3->set('receipts', $res['receipts']);
			$this->f3->set('page_data', $this->model->page_data('online_order_result'));
		}
		else { // Выводим ошибку
			$txt='';
			foreach ($res['error'] as $er) {
				$txt.=$this->messages->message($er)['txt'].'<br>';
			}
			$res['txt']=$txt;
			echo json_encode($res);
			exit();
		}
	}

	// Добавляем заказ к чеку
	function post_search_online_order() {
		$order=json_decode(urldecode($this->f3->get('POST.order')), true);
		// Узнаем открытый чек
		$receipt=$this->model->get_open_receipt($this->api_data['rm_id'], $this->api_data['store_id'], false);
		// Если чек пустой, то добавим заказ в него
		$this->receiptlines->reset();
		$lines=$this->receiptlines->count(array('receipt_id=?', $receipt['receipt']['id']));
		if($lines>0) {
			// Если чек не пустой, создадим новый чек
			$this->model->open_new($this->api_data['rm_id'], $this->api_data['store_id']);
		}
		$receipt_id=$this->f3->get('SESSION.receipt_id');
		$res=$this->model->push_order($receipt_id, $order);

		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Печать пречека или товарного чека
	function print() {
		$id=$this->f3->get('GET.id');
		if(!is_numeric($id)) {
			$id=$this->f3->get('SESSION.receipt_id');
		}
		$res=$this->model->print($id);
		if($res['success']) {
			$this->f3->set('device', $this->device);
			$this->f3->set('page_data', $this->model->page_data('print'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message($res['txt']));
		}
	}

	// Фискализация удаленных документов
	function fiscalization($n) {
		if($n>=10) {
			return array(
				'success'=>false,
				'txt'=>$this->messages->message('error')['txt']
			);
		}
		$receipts=$this->model->find(array('remote>0 AND time<0'), array('order'=>'remote'));
		if(!$receipts) {
			$res=array(
				'success'=>true,
				'txt'=>'not_remote_fiscalization'
			);
		}
		else {
			// Узнаем смену и если что откроем ее
			$change=$this->changes->get_change();
			// Узнаем состояние смены на ФР
			$fr=new \Models\Fr($this->db, $this->f3);
			// closed - закрыта
        	// opened - открыта
        	// expired - истекла
			$change_status=$fr->change_status();
			if($change_status=='closed') { // Смена закрыта, хотя в программе мы ее открыли
				// Надо открыть смену на ФР
				$fr->open_session(0);
			}
			elseif($change_status=='expired') { // Смена истекла
				// Надо закрыть смену и начать заново
				$ch=new \Models\Changes($this->db, $this->f3);
				$z=$ch->z($change);
				if(!$z['success']) {
					return $z;
				}
				return $this->fiscalization($n+1);
			}
			
			foreach ($receipts as $receipt) {
				// Узнаем товары
				$lines=$this->receiptlines->select_lines(array('receipt_id=?', $receipt['id']));
				$sum=$receipt['sum'];
				// Оплата
				$pay=$this->f3->get('e_paymethod');
				$paymentmethods=array(
					$pay
				);
				$client_sum=array(
					$pay=>$sum
				);
				// Проводим документ
				$res=$this->model->add_ticket($receipt['id'], $change, $this->receipts_types['sales'], $paymentmethods, $client_sum, $sum, $lines, $receipt['client'], 0, $receipt['partner_id'], 0, 0);
				if($res['success']) {
					$res['txt']='fiscalization_successful';
				}
				else {
					break;
				}
			}
		}
		$this->model->reset();
		$res['remote_receipts']=$this->model->count(array('remote>0 AND time<0'));
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		if($this->f3->get('GET.close')) {
			$res['close_all_window']=true;
		}
		echo json_encode($res);
		exit();
	}

	// Окно для отметки прохода сотрудника
	function walk() {
		$this->f3->set('page_data', $this->model->page_data('walk'));
	}
	function walk_add_card() {
		$barcode=$this->f3->get('POST.barcode');
		if(!$barcode) {
			$barcode=$this->f3->get('GET.barcode');
		}
		$this->f3->set('barcode', $barcode);
		$this->f3->set('page_data', $this->model->page_data('walk_add_card'));
	}

	// Отмечаем сотрудника
	function post_walk() {
		$data=$this->f3->get('POST');
		$data['type']=$this->f3->get('receipt_walk');
		$data['rm']=$this->api_data['rm_id'];
		$data['store']=$this->api_data['store_id'];
		$res=$this->model->validate_walk($data);
		if($res['success']) {
			$res=$this->model->add_walk($res['data']);
		}
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Окно вкрытия бутылки
	function chpok() {
		$barcode=$this->f3->get('GET.barcode');
		$product_id=$this->f3->get('GET.product_id');
		$products=array();
		if($barcode && !$product_id) {
			$prods=$this->products->search($barcode, 0, null, true);
			$products=$prods;
		}
		if($product_id) {
			$prods=$this->products->select_product(array('p.id=?', $product_id), array('limit'=>1));
			if(count($prods)>0) {
				$products=array(
					'success'=>true,
					'count'=>count($prods),
					'products'=>$prods
				);
			}
			else {
				$products=array(
					'success'=>false,
					'count'=>0,
					'products'=>array()
				);
			}
		}
		$this->f3->set('products', $products);
		if($products && $products['count']==1) {
			$this->f3->set('page_data', $this->model->page_data('chpok_end'));
		}
		else {
			$this->f3->set('page_data', $this->model->page_data('chpok'));
		}
	}

	// Вскрытие бутылки
	function post_chpok() {
		$post=$this->f3->get('POST');
		$product=$this->products->select_product(array('p.id=?', $post['product_id']), array('limit'=>1));
		if(!$product) {
			$res=array(
				'success'=>false,
				'txt'=>$this->messages->message('not_found')['txt']
			);
			echo json_encode($res);
			exit();
		}

		if($this->sets['check_egais']>0 && $this->sets['egais']==1 && $product[0]['egais']==1 && (!$post['not_check_mark'] || $this->sets['check_egais']==2)) {
			// Проверяем товар ЕГАИС
			$egais_res=$this->model->check_egais($post['code']);
			if($egais_res['success']===false) {
				$this->f3->set('mark_code', $post['code']);
				$this->f3->set('txt', $this->messages->message($egais_res['txt'])['txt']);
				$this->f3->set('page_data', $this->model->page_data('chpok_egais_error'));
				return;
			}
		}
		
		// Добавляем бутылку к чеку
		// Узнаем смену
		$change=$this->changes->get_change();
		// Узнаем сумму строк
		$sum=0;
		$post['sum']=$sum;
		$res=$this->model->ticket_chpok($this->api_data['rm_id'], $this->api_data['store_id'], $change);
		$receipt_id=$res['id'];
		$receipt=$res['receipt'];
		if($res['success']) {
			// Добавляем строки
			$product[0]['mark']=json_encode(array($post['code']));
			$product[0]['description']='Вскрытие тары';
			$product[0]['count']=0;
			$res=$this->receiptlines->add_line($receipt_id, $product[0], 0);
			if($res['success']) {
				$res=$this->model->ticket_chpok_ready($receipt, $product);
			}
			else {
				$this->model->delete_receipt($receipt_id);
			}
		}
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Добавить номер новой карты в чек
	function new_card() {
		$this->f3->set('new_partner', true);
		$this->add_partner();
	}

	// Окно для выбора модификатора для товара
	function modifiers() {
		$products=array();
		$line_id=$this->f3->get('GET.line_id');
		$line=$this->receiptlines->select_lines(array('id=?', $line_id), array('limit'=>1));
		if($line[0]['parent_id']>0) {
			$line=$this->receiptlines->select_lines(array('id=?', $line[0]['parent_id']), array('limit'=>1));
		}
		if($line) {
			$products=$this->products->modifiers($line[0]['product_id']);
		}
		if($products) {
			$this->f3->set('line', $line[0]);
			$this->f3->set('products', $products);
			$modifiers=$this->receiptlines->select_lines(array('parent_id=?', $line[0]['id']));
			if($modifiers) {
				$modifiers=array_combine(array_column($modifiers, 'product_id'), array_column($modifiers, 'count'));
			}
			$this->f3->set('modifiers', $modifiers);
			$page_data=$this->model->page_data('modifiers');
		}
		else {
			$page_data=$this->messages->message('not_found');
		}
		$this->f3->set('page_data', $page_data);
	}
}
