<?php
namespace Models;

// Модель клиентов
class Partners extends \DB\SQL\Mapper {
	public $db, $f3;

	public function __construct($db, $f3) {
		parent::__construct($db, 'partners' ); // подключаемся к таблице клиентов
		$this->db=$db;
		$this->f3=$f3;
	}

	function page_data($page='search') {
		$pages=array(
			'search'=>array(
				'title'=>'Поиск клиентов',
				'inc'=>'partners_search.htm'
			),
			'search_result'=>array(
				'title'=>'Результат поиска клиентов',
				'inc'=>'partners_search_result.htm'
			),
			'not_found'=>array(
				'title'=>'Клиент не найден',
				'inc'=>'partners_not_found.htm'
			)
		);
		$pages[$page]['page']=$page;
		return $pages[$page];
	}

	// Выбор из базы
	function select_partner($query=null, $options=null) {
		$partners=array();
		$this->load($query, $options);
		if($this->dry()) {
			return $partners;
		}
		do {
			$partners[]=$this->cast();
		}
		while($this->skip());
		$this->reset();
		return $partners;
	}

	// Формирование запроса для поиска
	function validate_q($q) {
		$q=preg_replace('~[^0-9]~','',$q);
		$l=mb_strlen($q);
		if($l==0) {
			$q=-1;
		}
		if($l<13) {
			$order='phone';
			if($l==11) {
				if(mb_substr($q, 0, 1)=='8') {
					$q='7'.mb_substr($q, 1);
				}
				$sql='phone=?';
				$val=$q;
			}
			else {
				$sql.='phone LIKE ?';
				$val='%'.$q.'%';
			}
		}
		else {
			$order='card';
			$sql='card=?';
			$val=$q;
		}
		return array(
			'sql'=>$sql,
			'val'=>$val,
			'order'=>$order
		);
	}
}
